<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
	import="java.util.ArrayList"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	
	Integer[] pools = Values.getInt(request.getParameterValues("pools"));
	
	int libPlateId = Values.getInt(request.getParameter("bioplate"));
	BioPlate libPlate = libPlateId == 0 ? null : BioPlate.getById(dc, libPlateId);
	String view = Values.getString(request.getParameter("view"), "list");
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<%
	if (libPlate != null)
	{
		%>
		<title>Lab protocol for pooling <%=HTML.encodeTags(libPlate.getName())%> - <%=view.equals("list") ? "list" : "table"%></title>
		<%
	}
	else
	{
		%>
		<title>Lab protocol for library pooling - <%=view.equals("list") ? "list" : "table"%></title>
		<%
	}
	%>
	<link rel="SHORTCUT ICON" href="<%=home%>/images/flowcell.png">
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/printable.css">
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/plate.css">
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/reggie.css">
	<script language="JavaScript" src="<%=root%>/include/scripts/main.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="<%=root%>/include/scripts/ajax.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="<%=home %>/reggie.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="pools.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="plate.js" type="text/javascript" charset="UTF-8"></script>
	
	<script language="JavaScript">
	var debug = false;
	var currentStep = 1;
	
	// Loaded from servlet when getting Library information
	var TARGET_MOLARITY_IN_POOL;
	var TARGET_VOLUME_IN_POOL_PER_LIB;	
	var POOL_SCHEMA;
	var POOL_BARCODE_VARIANT;
	
	function init()
	{
		// Load information about Library bioplate
		var libPlate;
		<%
		if (libPlateId != 0)
		{
			%>
			// Load Libraries and related info from the selected pools
			var request = Ajax.getXmlHttpRequest();
			try
			{
				showLoadingAnimation('Loading library bioplate information...');
				var url = '../Pool.servlet?ID=<%=ID%>&cmd=GetLibPlateInfo&bioplate=<%=libPlateId%>';		
				request.open("GET", url, false);
				request.send(null);
			}
			finally
			{
				hideLoadingAnimation();
			}
			
			if (debug) Main.debug(request.responseText);
			var response = JSON.parse(request.responseText);
			if (response.status != 'ok')
			{
				setFatalError(response.message);
				return false;
			}
			
			libPlate = response.libPlate;
			POOL_SCHEMA = PoolSchema.getById(libPlate.poolSchema);
			POOL_BARCODE_VARIANT = PoolSchema.getBarcodeVariantByName(POOL_SCHEMA, libPlate.barcodeVariant);
			<%
		}
		%>
		
		var pools = [<%=Values.getString(java.util.Arrays.asList(pools), ",", true)%>];

		// Load Libraries and related info from the selected pools
		var request = Ajax.getXmlHttpRequest();
		try
		{
			showLoadingAnimation('Loading pooled library information...');
			var url = '../Pool.servlet?ID=<%=ID%>&cmd=GetLibraryInfoForPools&pools='+pools.join(',');		
			request.open("GET", url, false);
			request.send(null);
		}
		finally
		{
			hideLoadingAnimation();
		}
		
		if (debug) Main.debug(request.responseText);
		var response = JSON.parse(request.responseText);
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		
		var pools = response.pools;
		var poolInfo = response.poolInfo;
		TARGET_MOLARITY_IN_POOL = poolInfo.targetMolarity;
		TARGET_VOLUME_IN_POOL_PER_LIB = poolInfo.targetVolumePerLib;

		var pageTitle = 'Lab protocol for pooling ';
		// Pre-process the Library items
		for (var i = 0; i < pools.length; i++)
		{
			var pool = pools[i];
			if (i > 0) pageTitle += ','
			pageTitle += ' ' + pool.name;
			for (var j = 0; j < pool.libraries.length; j++)
			{
				checkAndPreProcessLibrary(pool.libraries[j], POOL_SCHEMA, POOL_BARCODE_VARIANT);				
			}
		}
		
		if (!libPlate)
		{
			document.title = pageTitle + ' - <%=view%>';
		}
		
		<%
		if (view.equals("list"))
		{
			%>
			viewAsList(pools, POOL_SCHEMA, POOL_BARCODE_VARIANT);
			<%
		}
		else
		{
			%>
			viewAsPlate(pools, POOL_SCHEMA, POOL_BARCODE_VARIANT)
			<%
		}
		%>
	}
	
	function checkAndPreProcessLibrary(lib, schema, barcodeVariant)
	{
		var well = lib.bioWell;
		var remarks = [];

		// Check if default barcode has been modified
		if (barcodeVariant)
		{
			var indexSet = barcodeVariant.indexSets[well.column];
			if (indexSet)
			{
				var defaultBarcode = indexSet.barcodes[well.row];
				if (defaultBarcode && lib.barcode.name != defaultBarcode)
				{
					remarks[remarks.length] = 'Modified barcode';
					lib.barcode.modified = true;
				}
			}
		}
		
		if (lib.molarity)
		{
			if (lib.speedVacConc != null)
			{
				remarks[remarks.length] = 'SpeedVac';
			}
			if (lib.volume > TARGET_VOLUME_IN_POOL_PER_LIB + 0.001) 
			{
				remarks[remarks.length] = 'Use 5 µl';
			}
	
			if (lib.mixFactor > 1.001)
			{
				// Larger mix than default
				var mixedVolume = (lib.volume+lib.eb)*(lib.mixFactor);
				remarks[remarks.length] = 'Mix ' + Numbers.formatNumber(mixedVolume, 0) + 'µl';
			}

			lib.remarks = remarks;
		}
		
		if (lib.comment) remarks[remarks.length] = lib.comment;
	}
	
	/**
		Get the plate coordinate string for a well, optionally including the plate
		name or not.
	*/
	function getPlateCoordinate(well, includePlateName)
	{
		var c = '';
		if (well)
		{
			if (includePlateName) c += well.bioPlate.name;
			c += ' ' + WELL_ALPHA[well.row] + (well.column+1);
		}
		return c;
	}
	
	
	function viewAsList(pools, schema, barcodeVariant)
	{
		var lastPoolNum = -1;
		for (var i = 0; i < pools.length; i++)
		{
			var pool = pools[i];
			
			var html = '';
			var tbody = document.getElementById('listview.'+pool.id+'.body');
			
			for (var j = 0; j < pool.libraries.length; j++)
			{
				var lib = pool.libraries[j];
				var well = lib.bioWell;
				
				var tr = document.createElement('tr');
				tr.className = well.column % 2 == 0 ? "evencol" : "oddcol";
		
				if (barcodeVariant)
				{
					var indexSet = barcodeVariant.indexSets[well.column];
					if (indexSet)
					{
						tr.className = lib && lib.barcode.modified ? 'bg-modified' : indexSet.color;
					}
				}

				addColumn(tr, 'lib', lib.name);
				addColumn(tr, 'remain', Numbers.formatNumber((lib.remainingQuantity+lib.usedQuantity)*1000, 2));
				addColumn(tr, 'molarity', Numbers.formatNumber(lib.molarity, 2));
				<%
				if (libPlate==null)
				{
					%>
					addColumn(tr, 'workplate', well.bioPlate.name + ' ' + well.location);
					<%
				}
				else
				{
					%>
					addColumn(tr, 'workplate', well.location);
					<%
				}
				%>
				var mixFactor = lib.mixFactor || 1.0;
				addColumn(tr, 'volume', Numbers.formatNumber(lib.volume*mixFactor, 1));
				addColumn(tr, 'eb', Numbers.formatNumber(lib.eb*mixFactor, 1));
				addColumn(tr, "remarks", lib.remarks.join('; '));
				tbody.appendChild(tr);
			}
			
			setInnerHTML('molarity.'+pool.id, Numbers.formatNumber(pool.molarity, 2) + ' nM; ' + Numbers.formatNumber(1000*pool.originalQuantity / pool.conc, 0)+' µl');
			Main.show('pool.'+pool.id);
		}
	}
	
	function addColumn(tr, className, html)
	{
		var td = document.createElement('td');
		td.className = className;
		td.innerHTML = html;
		tr.appendChild(td);
	}
	
	function viewAsPlate(pools, schema, barcodeVariant)
	{
		Plate.init(8, 12, schema, WellPainter);
		
		for (var poolNo = 0; poolNo < pools.length; poolNo++)
		{
			var pool = pools[poolNo];
			POOL_NAMES[poolNo] = pool.name;
			for (var libNo = 0; libNo < pool.libraries.length; libNo++)
			{
				var lib = pool.libraries[libNo];
				var well = lib.bioWell;
				Plate.getWell(well.row, well.column).setExtract(lib);
			}
		}

		WellPainter.barcodeVariant = barcodeVariant;
		Plate.paint(Plate.getWells());
		PoolSchema.buildPoolTableRow(schema, 12);
		Main.show('plateview');
		
		
		for (var poolNo = 0; poolNo < pools.length; poolNo++)
		{
			var pool = pools[poolNo];
			//setInnerHTML('molarity.'+pool.id, Numbers.formatNumber(pool.molarity, 2) + ' nM; ' + Numbers.formatNumber(1000*pool.originalQuantity / pool.conc, 0)+' µl');

			var poolData = '<div class="pool-data">';
			poolData += Numbers.formatNumber(pool.molarity, 2)+'nM; ';
			poolData += Numbers.formatNumber(1000*pool.originalQuantity / pool.conc, 0) + 'µl';
			poolData += '</div>';
			document.getElementById('pool.'+poolNo).innerHTML = POOL_NAMES[poolNo] + poolData;

		}
	}

	var WellPainter = function()
	{
		var painter = {};
		
		painter.getClassNameForWell = function(well, schema)
		{
			var cls = '';
			var indexSet = painter.barcodeVariant.indexSets[well.column];
			if (indexSet)
			{
				var lib = well.extract;
				cls += lib && lib.barcode.modified ? 'bg-modified' : indexSet.color;
			}
			return cls;
		}
		
		painter.getWellText = function(well, schema)
		{
			var text = '';
			var lib = well.extract;
			if (lib)
			{
				var name = lib.name;
				var mixFactor = lib.mixFactor || 1.0;
				var i = name.indexOf('.m');
				text += '<div class="lib">'+name.substring(0, i)+'.<br>&nbsp;'+name.substring(i)+'</div>';
				text += '<div><span class="volume">'+Numbers.formatNumber(lib.volume*mixFactor, 1)+'µl</span>';
				text += '<span class="eb">'+Numbers.formatNumber(lib.eb*mixFactor, 1)+'µl</span></div>';
				text += '<div class="remarks">'+ lib.remarks.join('; ') + '</div>';
			}
			return text;
		}

		return painter;
	}();
	</script>
	<style>
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		margin-bottom: 1em;
		border-collapse: collapse;
	}

	table.protocolheader > tbody > tr
	{
		vertical-align: top;
		height: 1.25em;
	}

	table.protocolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1em;
		background-color: #F0F0F0;
		padding: 2px;
	}
	
	table.protocolheader > tbody > tr > td
	{
		text-align: left;
		font-size: 1em;
		padding: 2px;
	}

	.pool-section
	{
		page-break-inside: avoid;
	}

	table.poolheader
	{
		margin-top: 1em;
		width: 100%;
		border: 1px solid #000000;
		border-bottom: 0px;
		border-collapse: collapse;
	}

	table.poolheader > tbody > tr
	{
		height: 1.25em;
	}

	table.poolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1em;
		padding: 1px;
	}
	
	.listview
	{
		width: 100%;
		font-size: 85%;
		border-collapse: collapse;
		border: 1px solid #000000;
	}
	
	.listview tr.oddcol
	{
		background-color: #F0F0F0;
	}
	
	.listview thead
	{
		border: 1px solid #000000;
		background-color: #F0F0F0;
	}
	
	.listview th
	{
		border-left: 1px solid #000000;
	}
	
	.listview td
	{
		border-left: 1px solid #000000;
		border-top: 1px dotted #666666;
		vertical-align: middle;
	}
	
	.listview .col-num
	{
		width: 1.75em;
		text-align: center;
		font-size: 125%;
		font-weight: bold;
		vertical-align: top;
	}
	
	.listview .lib
	{
		width: 15em;
		text-align: center;
	}
	
	.listview .empty .lib
	{
		font-style: italic;
		color: #666666;
		text-align: center;
	}
	
	.listview .workplate
	{
	
		width: <%=libPlate==null ? "14em" : "7em"%>;
		text-align: center;
	}
	
	.listview .pool
	{
		width: 7em;
		text-align: center;
	}
	
	.listview .remain, .listview .molarity
	{
		width: 4.5em;
		padding-right: 0.5em;
		text-align: right;
	}

	.listview .volume
	{
		width: 3.5em;
		padding-right: 0.5em;
		text-align: right;
		color: #C80000;
	}
	
	.listview .eb
	{
		width: 3.5em;
		padding-right: 0.5em;
		text-align: right;
		color: #0000C8;
	}
	
	.listview .remarks
	{
		vertical-align: top;
		padding-left: 0.25em;
	}
	
	/* Divide the 12 wells across the full page */
	#plateview .well
	{
		width: 8.2%;
		max-width: 8.2%;
		min-width: 8.2%;
		padding: 4px;
	}
	
	#plateview .well:hover
	{
		padding: 3px;
	}
	
	#plateview .rowheader
	{
		width: 2em;
	}
	
	#plateview .lib
	{
		font-weight: bold;
		margin-bottom: 0.25em;
	}
	#plateview .volume
	{
		color: #C80000;
	}
	#plateview .eb
	{
		color: #0000C8;
		float: right;
	}
	
	#plateview .remarks
	{
		color: #C80000;
		font-style: italic;
	}
	#plateview .pool-data
	{
		font-weight: normal;
	}
	</style>
</head>
<body onload="init()">
	<div class="paper <%=view.equals("list") ? "" : "landscape"%>">
	<div class="noprint fullwidth" style="border-bottom: 1px dashed #A0A0A0; padding-left: 1em; padding-bottom: 1em;">
		<span class="button" onclick="window.print()" style="float: left; margin-right: 1em;">
			<img src="../images/print.png">Print&hellip;
		</span>
		<b>Note!</b> 
		<%
		if (view.equals("list"))
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>portrait</i>. To fit everything on a single page, scale down to <i>60-70%</i>.
			<%
		}
		else
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>landscape</i>. The recommended scale is <i>100%</i>.
			<%
		}
		%>
		<br clear="all">
	</div>
	
	<h1>Lab protocol for library pooling <span class="reggie">Reggie <%=reggie.getAbout().getVersion() %></span></h1>

	<table style="width: 100%;" class="protocolheader">
	<tr style="border-bottom: 1px solid #000000;">
		<th style="width: 15%;">Library plate</th>
		<td style="width: 30%; border-right: 1px solid #000000;"><%=libPlate == null ? "Multiple" : HTML.encodeTags(libPlate.getName())%></td>
		<th style="width: 15%;"></th>
		<th style="width: 20%;">Date</th>
		<th style="width: 20%;">Operator</th>
	</tr>
	<tr>
		<td rowspan="1" colspan="2" style="width: 50%; border-right: 1px solid #000000;"><%=libPlate != null ? HTML.niceFormat(libPlate.getDescription()) : ""%></td>
		<td style="border-right: 1px solid #000000;">Pooling</td>
		<td style="border-right: 1px solid #000000;"></td>
		<td></td>
	</tr>
	</table>

	<%
	if (view.equals("list"))
	{
		for (Integer poolId :pools)
		{
			Extract pool = Extract.getById(dc, poolId);
			%>
			<div id="pool.<%=poolId%>" style="display: none;" class="pool-section">
			<table style="width: 100%;" class="poolheader">
			<tr valign="top">
				<th style="width: 40%;"><%=HTML.encodeTags(pool.getName())%></th>
				<th style="width: 60%">Comments:</th>
			</tr>
			<tr valign="top">
				<td style="width: 40%;"><span id="molarity.<%=poolId%>"></span></td>
				<td><%=HTML.niceFormat(pool.getDescription()) %></td>
			</tr>
			</table>
			<table style="width: 100%;" class="listview" id="listview.<%=poolId%>">
			<thead>
				<tr class="toprow">
					<th class="lib"></th>
					<th>Remain</th>
					<th>DNA</th>
					<th class="workplate">Work</th>
					<th colspan="2">2nM, 5/10µl</th>
					<th></th>
				</tr>
				<tr>
					<th class="lib">Library</th>
					<th>(ng)</th>
					<th>(nM)</th>
					<th class="workplate">plate</th>
					<th>(µl)</th>
					<th>EB</th>
					<th>Remarks</th>
				</tr>
			</thead>
			<tbody id="listview.<%=poolId%>.body">
			</tbody>
			</table>
			</div>
			<%
		}
	}
	%>

	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	<div class="messagecontainer error" id="errorMessage" style="display: none;"></div>
	<%

	if (view.equals("plate"))
	{
		%>
		<table class="plate" style="margin: 0em 0 0 0; width: 100%; display: none;" id="plateview">
		<%
		WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
		WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
		%>
		<tr class="header">
			<th></th>
			<%
			for (int c = 0; c < libPlate.getColumns(); ++c)
			{
				%>
				<th id="col.<%=c%>"><%=colF.format(c)%></th>
				<%
			}
			%>
		</tr>
		<tbody>
		<%
		for (int r = 0; r < libPlate.getRows(); ++r)
		{
			String row = rowF.format(r);
			%>
			<tr class="row-<%=r%>">
				<th id="row.<%=r%>" class="rowheader"><%=row%></th>
				<%
				for (int c = 0; c < libPlate.getColumns(); ++c)
				{
					%>
					<td class="well col-<%=c%>" id="well.<%=r%>.<%=c%>"></td>
					<%
				}
				%>
			</tr>
			<%
		}
		%>
		</tbody>
		<tr id="pool-row">
			<th colspan="13">&nbsp;</th>
		</tr>
		</table>
		<%
	}
	%>
	</div>
</body>
</html>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>